<?php

/**

 * Plugin Name: CookiePro CCPA

 * Plugin URI: http://www.onetrust.com/

 * Version: 1.0.3

 * Author: OneTrust, Llc

 * Author URI: https://www.onetrust.com/products/cookies/

 * Description: CookiePro is the most mature and trusted cookie consent tool that is purpose-built for compliance with CCPA, GDPR, ePrivacy, and IAB framework. This plug-in gives the ability to easily add a Do Not Sell button or link to your website.

 * License: GPL2

 *

 * @package CookieProCCPA

 */



/*

	Copyright 2018 OneTrust



	This program is free software; you can redistribute it and/or modify

	it under the terms of the GNU General Public License, version 2, as

	published by the Free Software Foundation.



	This program is distributed in the hope that it will be useful,

	but WITHOUT ANY WARRANTY; without even the implied warranty of

	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

	GNU General Public License for more details.



	You should have received a copy of the GNU General Public License

	along with this program; if not, write to the Free Software

	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
defined( '_JEXEC' ) or die;

class plgSystemCookieproccpa extends JPlugin{
	function onBeforeCompileHead() {
		$app = Joomla\CMS\Factory::getApplication();
		$document = JFactory::getDocument();
        if ($app->getName() == "site") {
        	if(!Joomla\CMS\HTML\HTMLHelper::isRegistered('jquery.framework')) {
        		Joomla\CMS\HTML\HTMLHelper::_('jquery.framework');
        	}
        	
			$document->addStyleSheet("https://fonts.googleapis.com/css?family=Open+Sans:400,700&display=swap");
			$document->addStyleSheet(JURI::base(). "media/plg_system_cookieproccpa/css/ot-ccpa-style.css");
			$document->addStyleDeclaration(
				'#ot-ccpa-banner .ot-ccpa-icon { background-color: '.$this->params->get('ccpa_header_text_background'). '; }'
			);

			if ( $this->params->get('ccpa_insert_link') == 0) {
				$document->addStyleDeclaration('#otCCPAdoNotSellLink{ display: none !important; }');
			}

			if ( $this->params->get('ccpa_insert_button') == 0) {
				$document->addStyleDeclaration('#otCCPAdoNotSellButton{ display: none !important; }');
			}
		}
		else {
			$document->addStyleDeclaration('.ccpa_pointer{cursor: pointer !important;}');
		}
	}

	function onAfterRender() {
		$app = Joomla\CMS\Factory::getApplication();
        if ($app->getName() == "site") {
        	$class = $emailId = $phoneNo = $iabVal = $isGooglePersonalizeEnabled = $googlePersontitle = $googlePersonDescription = $confrimText = $dsarTitle = $dsarLink = '';
        	$displayEmail = $displayPhone = $dsarStatus = $lspa = "false";

        	/* CCPA Floating Button */
        	if($this->params->get('ccpa_floating_button') == 1) {

				$otCcpaIconPos = "flex"; 
			}
			else {
				$otCcpaIconPos = 'none';
			}

        	if('Right' === $this->params->get('ccpa_button_position')) {
				$class = 'CCPAFloatRight';
			}

        	$bg_url = JURI::base()."media/plg_system_cookieproccpa/images/icon.png";

			if (!empty( $this->params->get('ccpa_icon'))) {
				$bg_url = JURI::base()."/".$this->params->get('ccpa_icon');
			}

        	$otCcpa = '<div id="ot-ccpa-banner" class="'.$class.'" data-ot-ccpa-opt-out="buttonicon">
				<div class="ot-ccpa-icon '.$class.'" style="display:'.$otCcpaIconPos.'">
					<a href="javascript:void(0);"><img src="'.$bg_url.'" alt="Popup Button" title="CookiePro Do Not Sell" width=36 height=36 /></a>
				</div>
			</div>';

        	/* Display Email Address status */
        	if($this->params->get('ccpa_display_email_address') == 1) {
        		$displayEmail = "true";
        		$emailId = trim($this->params->get('ccpa_email_address'));
        	}

        	/* Display Phone Number status */
        	if($this->params->get('ccpa_display_phone_number') == 1) {
        		$displayPhone = "true";
        		$phoneNo = trim($this->params->get('ccpa_phone_number'));
        	}

        	/* Display Consumer Rights Form status */
        	if($this->params->get('ccpa_consumer_rights_form') == 1) {
        		$dsarStatus = "true";
        		$dsarTitle = trim($this->params->get('ccpa_link_label'));
        		$dsarLink = trim($this->params->get('ccpa_form_url'));
        	}

        	/*GooglePersonalize status*/
        	if($this->params->get('ccpa_opt_out_google') == 1) {
        		$isGooglePersonalizeEnabled = "gam";
        		$googlePersontitle = $this->params->get('ccpa_personalized_advertisements');
        		$googlePersonDescription = $this->params->get('ccpa_google_opt_out_message');
        		$confrimText = $this->params->get('ccpa_confirm_label');

        		/* IAB CCPA status */
	        	if($this->params->get('ccpa_iab_status') == 1) {
	        		$iabVal = "iab";
	        		/* LSPA status */
	        		if($this->params->get('ccpa_lspa_status') == 1) {
	        			$lspa = "true";
	        		}
	        	}	        	
        	}

        	$otCcpa .= '
        	<!-- CookiePro CCPA Opt-Out Script Start -->
        	<script>
	        	var otCcpaData = {
					dialogueLocation: "'.strtolower($this->params->get('ccpa_button_position')).'",
					primaryColor: "'.$this->params->get('ccpa_header_text_background').'",
					secondaryColor: "'.$this->params->get('ccpa_header_text').'",
					btnPrimaryColor: "'.$this->params->get('ccpa_button_background').'",
					btnSecondaryColor: "'.$this->params->get('ccpa_button_text').'",
					emailDisplay: '.$displayEmail.',
					email: "'.$emailId.'",
					phoneDisplay: '.$displayPhone.',
					phone: "'.$phoneNo.'",
					dsarDisplay: '.$dsarStatus.',
					dsarTitle: "'.$dsarTitle.'",
					dsarUrl: "'.$dsarLink.'",
					title: "'.trim($this->params->get('ccpa_title')).'",
					description: "'.trim($this->params->get('ccpa_message')).'",
					privacyTitle: "'.trim($this->params->get('ccpa_policy_label')).'",
					privacyUrl: "'.trim($this->params->get('ccpa_policy_url')).'",
					isGooglePersonalizeEnabled: "'.trim($isGooglePersonalizeEnabled).'",
					googlePersontitle: "'.trim($googlePersontitle).'",
					googlePersonDescription: "'.trim($googlePersonDescription).'",
					iabVal: "'.$iabVal.'",
					location: "'.trim($this->params->get('ccpa_user_access')).'",
					confrimText: "'.trim($confrimText).'",
					floatingButton: "'.$this->params->get('ccpa_floating_button').'",
					lspaStatus: '.$lspa.'
		   		};
		    </script>
		    <script src="'.JURI::base().'media/plg_system_cookieproccpa/js/ot-ccpa-script.js"></script>
		    <!-- CookiePro CCPA Opt-Out Script End --> ';

        	$html = $app->getBody();
            $html = str_replace('</body>',$otCcpa.'</body>',$html);
            $app->setBody($html);
        }
	}
}